Multicourbe(L):={
local Fns,F,f,B;
local jj,dx,nbp,P;
local xmin,xmax,ymin,ymax,ux,uy,cx,cy,gx,gy;
local textp,ip,etatc,val;
local T,N,No,V,textt;
local t,a,b,xtmin,xtmax,dt,tmin,tmax,df;
local li,g,sol,texts;
local texta,Q,texti;
local G,g;
local valmin,valmax,nmod,hoteur,bmin,bmax,dl,legendey,legendex,modmin,modmax;

Fns:=L[0];
N:=size(Fns);



xmin:=L[1];
xmax:=L[2];
valmin:=L[3];
valmax:=L[4];

ux:=L[5];
cx:=L[6];
gx:=L[7];

hoteur:=L[8];


T:=L[9];

modmin:=simplifier(log10(valmin));
modmax:=simplifier(log10(valmax));
nmod := simplifier(log10(valmax/valmin));
dl:=evalf(hoteur/(nmod*ln(10)));
bmin:=simplifier(dl*ln(valmin));
bmax:=simplifier(dl*ln(valmax));

legendey:=("");
val:=valmin;
for(jj:=0;jj<=nmod;jj++)
{
  legendey:=concat(legendey,"label.lft(TEX(\" $ "+val+" $ \"),("+xmin+","+evalf(dl*ln(val))+") placer);
");
  val:=val*10;
}

legendex:=("graduationstatx.bot(xmin,xmax,ymin+dv*modmin,ymax+dv*modmin,dx,dy,carx);
");


textp:=("");

for(jj:=0;jj<N;jj++)
{
  F:=Fns[jj];
  f:=unapply(F[0],x);
  df:=unapply(deriver(F[0]),x);

  if (size(F)==3) then
  {
    B:=F[2];
    xtmin:=max(xmin,B[0]);
    xtmax:=min(xmax,B[1]);
  }
  else
  {
    xtmin:=xmin;
    xtmax:=xmax;
  }

  nbp:=200;
  dx:=evalf((xtmax-xtmin)/nbp);
  P:=makemat(0,1,nbp+1);


  etatc:=0;
  nbc:=0;


  for (j:=0;j<=nbp;j++)
  {
    x:=evalf(xtmin+j*dx);
    if (abs(x)<0.0001) then
    {
      x:=0;
    }
    val:=ln(f(x))*dl;
    if (abs(val)<0.0001) then
    {
      val:=0;
    }
    if ((val>bmin) and (val<bmax)and (val!=infinity) and (im(val)==0))
    {
      if (etatc==0) then
      {
        etatc:=1;
        nbc:=nbc+1;
        ip:=1;
        P[0]:=[x,val];
        textp:=concat(textp,"P[1]:=("+evalf(x)+","+evalf(val)+");
");
      }
      else
      {
        P[ip]:=[x,val];
        ip:=ip+1;
        textp:=concat(textp,"P["+(ip)+"]:=("+evalf(x)+","+evalf(val)+");
");
      }
     }
     else
     {
       if (etatc==1) then
       {
         etatc:=0;
         textp:=concat(textp,"

draw P[1] placer
for i:=2 upto ");
       textp:=concat(textp,""+ip+"");
       textp:=concat(textp,":
  ..P[i] placer
endfor
withcolor "+F[1]+" withpen pencircle scaled 1.5bp;

");
       }
     }
  }

  if (etatc==1) then
  {
    etatc:=0;
    textp:=concat(textp,"

draw P[1] placer
for i:=2 upto ");
textp:=concat(textp,""+ip+"");
textp:=concat(textp,":
  .. P[i] placer
endfor
withcolor "+F[1]+" withpen pencircle scaled 1.5bp;

");
  }

// dessin des extremites

  if (size(F)==3) then
  {
    B:=F[2];
    if (size(B)==3) then
    {
      if ((B[2]=="ff") or (B[2]=="fo")) then
      {
        tmin:=f(xtmin);
        if (abs(tmin)<0.0001) then
        {
          tmin:=0;
        }
        textp:=concat(textp,"dotlabel(TEX(\" \"),("+evalf(xtmin)+","+evalf(tmin)+")placer) withcolor  "+F[1]+";
");
      }
      if ((B[2]=="ff") or (B[2]=="of")) then
      {
        tmax:=f(xtmax);
        if (abs(tmax)<0.0001) then
        {
          tmax:=0;
        }
        textp:=concat(textp,"dotlabel(TEX(\" \"),("+evalf(xtmax)+","+evalf(tmax)+")placer) withcolor  "+F[1]+";
");
      }
    }
}

}//fin du for


                        //  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
                        //       % Traitement des options

No:=size(T);
textt:=("%%%%%%%%%%%%%%%% Complements %%%%%%%%%%%%%%%%%%%%%%%%

");

texti:=("%%%%%%%%%%%%%%%% titres %%%%%%%%%%%%%%%%%%%%%%%%

");

if (No!=0) then
{
  for(j:=0;j<=No-1;j++)
  {
    V:=T[j];




////////////////////////////////////////////////////////////////////////////////////////////////////

    if (V[0]=="point-courbe") then
    {
      textt:=concat(textt,"%%%%%%%%%%%%%%%% Point sur courbe %%%%%%%%%%%%%%%%%%%%%%%%

");
      F:=Fns[V[1]-1];
      f:=unapply(F[0],x);
      t:=V[2];
      val:=evalf(dl*ln(f(t)));
      if (abs(val)<0.0001) then
      {
        val:=0;
      }
      textt:=concat(textt,"label."+V[4]+"(TEX(\" "+V[3]+" \"),("+t+","+val+") placer) withcolor "+V[5]+";
");
      textt:=concat(textt,"draw("+t+","+evalf(val)+") placer shifted (-0.1cm,0)--("+t+","+val+") placer shifted (0.1cm,0) withcolor "+V[5]+";
");
          textt:=concat(textt,"draw("+t+","+evalf(val)+") placer shifted (0,-0.1cm)--("+t+","+val+") placer shifted (0,0.1cm) withcolor "+V[5]+";
");
      if (size(V)==7) then
      {
        if ((V[6,0]=="x") or (V[6,0]=="xy")) then
        {
          textt:=concat(textt,"draw("+t+","+evalf(dl*ln(valmin))+") placer--("+t+","+val+") placer dashed evenly withcolor  "+V[5]+";
");
          if (size(V[6])==1) then
          {
            if (val>0) then
            {
              textt:=concat(textt,"label.bot(TEX(\"$ "+latex(t)+" $\"),("+t+","+evalf(dl*ln(valmin))+") placer) withcolor  "+V[5]+";
");
            }
            else
            {
              textt:=concat(textt,"label.top(TEX(\"$ "+latex(t)+" $\"),("+t+","+evalf(dl*ln(valmin))+") placer) withcolor  "+V[5]+";
");
            }
          }
          else
          {
            if (val>0) then
            {
              textt:=concat(textt,"label.bot(TEX(\" "+V[6,1]+" \"),("+t+","+evalf(dl*ln(valmin))+") placer) withcolor  "+V[5]+";
");
            }
            else
            {
              textt:=concat(textt,"label.top(TEX(\" "+V[6,1]+" \"),("+t+","+evalf(dl*ln(valmin))+") placer) withcolor  "+V[5]+";
");
            }
          }
        }
        if ((V[6,0]=="y") or (V[6,0]=="xy")) then
        {
          textt:=concat(textt,"draw(xmin,"+evalf(val)+") placer--("+t+","+evalf(val)+") placer dashed evenly withcolor  "+V[5]+";
");
          if (size(V[6])==1) then
          {
            if (t>0) then
            {
              textt:=concat(textt,"label.lft(TEX(\"$ "+round(evalf(f(t)),3)+" $\"),(xmin,"+evalf(val)+") placer) withcolor  "+V[5]+";
");
            }
            else
            {
              textt:=concat(textt,"label.rt(TEX(\"$ "+round(evalf(f(t)),3)+" $\"),(xmin,"+evalf(val)+") placer) withcolor  "+V[5]+";
");
            }
          }
          else
          {
            if (t>0) then
            {
              textt:=concat(textt,"label.lft(TEX(\" "+V[6,2]+" \"),(xmin,"+evalf(val)+") placer) withcolor  "+V[5]+";
");
            }
            else
            {
              textt:=concat(textt,"label.rt(TEX(\" "+V[6,2]+" \"),(xmin,"+evalf(val)+") placer) withcolor  "+V[5]+";
");
            }

          }
        }
      }
    }





////////////////////////////////////////////////////////////////////////////////////////////////////

    if (V[0]=="point-libre") then
    {
      textt:=concat(textt,"%%%%%%%%%%%%%%%% Point libre %%%%%%%%%%%%%%%%%%%%%%%%

");
      xtmin:=evalf(V[1,0]);
      tmin:=evalf(dl*ln(V[1,1]));
      textt:=concat(textt,"label."+V[3]+"(TEX(\" "+V[2]+" \"),("+xtmin+","+tmin+") placer) withcolor "+V[4]+";
");
      textt:=concat(textt,"draw("+xtmin+","+tmin+") placer shifted (-0.1cm,0)--("+xtmin+","+tmin+") placer shifted (0.1cm,0) withcolor "+V[4]+";
");
      textt:=concat(textt,"draw("+xtmin+","+tmin+") placer shifted (0,-0.1cm)--("+xtmin+","+evalf(tmin)+") placer shifted (0,0.1cm) withcolor "+V[4]+";
");

      if (size(V)==6) then
      {
        if ((V[5,0]=="x") or (V[5,0]=="xy")) then
        {
          textt:=concat(textt,"draw("+xtmin+","+evalf(dl*ln(valmin))+") placer--("+xtmin+","+tmin+") placer dashed evenly withcolor  "+V[4]+";
");

          if (size(V[5])==1) then
          {
            if (tmin>0) then
            {
              textt:=concat(textt,"label.bot(TEX(\"$ "+latex(V[1,0])+" $\"),("+xtmin+","+evalf(dl*ln(valmin))+") placer) withcolor  "+V[4]+";
");
            }
            else
            {
              textt:=concat(textt,"label.top(TEX(\"$ "+latex(V[1,0])+" $\"),("+xtmin+","+evalf(dl*ln(valmin))+") placer) withcolor  "+V[4]+";
");
            }
          }
          else
          {
            if (tmin>0) then
            {
              textt:=concat(textt,"label.bot(TEX(\" "+V[5,1]+" \"),("+xtmin+","+evalf(dl*ln(valmin))+") placer) withcolor  "+V[4]+";
");
            }
            else
            {
              textt:=concat(textt,"label.top(TEX(\" "+V[5,1]+" \"),("+xtmin+","+evalf(dl*ln(valmin))+") placer) withcolor  "+V[4]+";
");
            }
          }
        }
        if ((V[5,0]=="y") or (V[5,0]=="xy")) then
        {
          textt:=concat(textt,"draw(0,"+tmin+") placer--("+xtmin+","+tmin+") placer dashed evenly withcolor  "+V[4]+";
");
          if (size(V[5])==1) then
          {
            if (xtmin>0) then
            {
              textt:=concat(textt,"label.lft(TEX(\"$ "+latex(V[1,1])+" $\"),(xmin,"+tmin+") placer) withcolor  "+V[4]+";
");
            }
            else
            {
              textt:=concat(textt,"label.rt(TEX(\"$ "+latex(V[1,1])+" $\"),(xmin,"+tmin+") placer) withcolor  "+V[4]+";
");
            }
          }
          else
          {
            if (xtmin>0) then
            {
              textt:=concat(textt,"label.lft(TEX(\" "+V[5,2]+" \"),(xmin,"+tmin+") placer) withcolor  "+V[4]+";
");
            }
            else
            {
              textt:=concat(textt,"label.rt(TEX(\" "+V[5,2]+" \"),(xmin,"+tmin+") placer) withcolor  "+V[4]+";
");
            }

          }
        }
      }
    }




////////////////////////////////////////////////////////////////////////////////////////////////////

    if (V[0]=="texte-courbe") then
    {
      textt:=concat(textt,"%%%%%%%%%%%%%%%% Texte lie a la courbe %%%%%%%%%%%%%%%%%%%%%%%%

");
      F:=Fns[V[1]-1];
      f:=unapply(F[0],x);
      t:=V[2];
      val:=evalf(dl*ln(f(t)));
      if (abs(val)<0.0001) then
      {
        val:=0;
      }
      texts:=V[3];
      textt:=concat(textt,"label."+V[4]+"(TEX(\" \\colorbox\{white\}\{\\textcolor\{"+V[5]+"\}\{");
      textt:=concat(textt,texts);
      textt:=concat(textt,"\}\} \"),("+evalf(t)+","+val+") placer);
");
    }



////////////////////////////////////////////////////////////////////////////////////////////////////

    if (V[0]=="texte-libre") then
    {
      textt:=concat(textt,"%%%%%%%%%%%%%%%% Texte libre %%%%%%%%%%%%%%%%%%%%%%%%

");
      xtmin:=evalf(V[1,0]);
      tmin:=evalf(V[1,1]);
      val:=evalf(dl*ln(tmin));
      if (abs(val)<0.0001) then
      {
        val:=0;
      }
      texts:=V[2];
      textt:=concat(textt,"label."+V[3]+"(TEX(\" \\colorbox\{white\}\{\\textcolor\{"+V[4]+"\}\{");
      textt:=concat(textt,texts);
      textt:=concat(textt,"\}\} \"),("+xtmin+","+val+") placer);
");
    }


////////////////////////////////////////////////////////////////////////////////////////////////////

    if (V[0]=="titre-gauche") then
    {
      texti:=concat(texti,"%%%%%%%%%%%%%%%% Titre a gauche %%%%%%%%%%%%%%%%%%%%%%%%

");
      texti:=concat(texti,"titre:=1;
");
      texti:=concat(texti,"label.rt(TEX(\" "+V[1]+" \"),(xmin,ymax+dv*modmin) placer shifted (0,0.7cm));
");
    }


////////////////////////////////////////////////////////////////////////////////////////////////////

    if (V[0]=="titre-droite") then
    {
      texti:=concat(texti,"%%%%%%%%%%%%%%%% Titre a droite %%%%%%%%%%%%%%%%%%%%%%%%

");
      texti:=concat(texti,"titre:=1;
");
      texti:=concat(texti,"label.lft(TEX(\" "+V[1]+" \"),(xmax,ymax+dv*modmin) placer shifted (0,0.7cm));
");
    }



////////////////////////////////////////////////////////////////////////////////////////////////////

    if (V[0]=="titre-centre") then
    {
      texti:=concat(texti,"%%%%%%%%%%%%%%%% Titre centre %%%%%%%%%%%%%%%%%%%%%%%%

");
      texti:=concat(texti,"titre:=1;
");
      texti:=concat(texti,"label(TEX(\" "+V[1]+" \"),((xmin+xmax)/2,ymax+dv*modmin) placer shifted (0,0.7cm));
");
    }


////////////////////////////////////////////////////////////////////////////////////////////////////

    if (V[0]=="sans-legende-y") then
    {
      legendey:=("");
    }

////////////////////////////////////////////////////////////////////////////////////////////////////

    if (V[0]=="sans-legende-x") then
    {
      legendex:=("");
    }







  }
}





                        //  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
                        //       % Creation du fichier metapost

Dessin:="
input dlf\_couleurs.mp;
input dlf\_tex.mp;
input dlf\_repere.mp;


vardef ln expr x = (mlog x) / 256 enddef;

vardef placerlog(expr a,b)=
(a*dx,(ln(b))*dl*dy)
enddef;

numeric xmin,xmax,ymin,ymax,dx,dy;
numeric carx,cary,gradx,grady;
xmin:="+xmin+";
xmax:="+xmax+";
ymin:=0;
ymax:="+hoteur+";
dx:=1cm/"+ux+";
dy:=1cm;
carx:="+cx+";
gradx:="+gx+";


numeric ybase;
ybase:=1;

numeric nmod,dv,dl,N,modmin,modmax;
modmin:="+modmin+";
modmax:="+modmax+";
nmod:="+nmod+";
dv:=(ymax-ymin)/nmod;
dl:=dv/(ln(10));

N:=xmax-xmin;

beginfig(0);



path PH,PV;
PH := (xmin,ymin) placer -- (xmax,ymin) placer;
PV := (xmin,ymin) placer --(xmin,ymax) placer;


% lignes verticales


for i:=0 upto (N-1) :
  draw PV shifted (i*1cm,modmin*dv*1cm);
  for j:=1 upto 9 :
    draw PV shifted (j*0.1cm,modmin*dv*1cm) shifted (i*1cm,0)  withpen pencircle scaled 0.5bp withcolor gris;
  endfor;
  draw PV shifted (0.5cm,modmin*dv*1cm) shifted (i*1cm,0)  withpen pencircle scaled 1bp withcolor gris;
endfor;
draw PV shifted (N*1cm,modmin*dv*1cm);

% lignes horizontales

for i:=modmin upto (modmax-1) :
  draw PH shifted (0,dv*i*1cm) withpen pencircle scaled 1.5bp;
  for j:=1 upto 9 :
    draw PH shifted (0,dl*(ln(j))*1cm) shifted (0,dv*i*1cm) withpen pencircle scaled 0.5bp;
    draw PH shifted (0,dl*(ln(j+0.5))*1cm) shifted (0,dv*i*1cm) withpen pencircle scaled 0.5bp withcolor gris;
  endfor;
endfor;
draw PH shifted (0,dv*modmax*1cm) withpen pencircle scaled 1.5bp;

% axe des ordonnes
draw (0,ymin) placer shifted (0,dv*modmin*1cm) --(0,ymax) placer shifted (0,dv*modmin*1cm) withpen pencircle scaled 1.5bp;

pair P[];

"+textp+"


path limite;
limite:=(xmin*dx,ymin*dy)--(xmax*dx,ymin*dy)--(xmax*dx,ymax*dy)--(xmin*dx,ymax*dy)--cycle;
%clip currentpicture to limite;


"+textt+"

"+legendex+"

"+legendey+"

% titre
numeric titre;
titre:=0;

"+texti+"

if (titre=1):
  draw (xmin,ymax+dv*modmin) placer shifted (0,0.1cm) --(xmax,ymax+dv*modmin) placer shifted (0,0.1cm) withpen pencircle scaled 1bp withcolor gris;
  draw (xmin,ymax+dv*modmin) placer shifted (0,1.3cm)--(xmax,ymax+dv*modmin) placer shifted (0,1.3cm) withpen pencircle scaled 1bp withcolor gris;
fi;


endfig;
end
";
}:;
